local plugin = InfoPanel:AddPlugin();
local info = {};
local free, type;

for i = 0, NUM_BAG_SLOTS do
	info[i] = {};
end

--------------------------------------------------------------------------------------------------------
--                                             Functions                                              --
--------------------------------------------------------------------------------------------------------

-- OnShowTooltip
function plugin:OnShowTooltip(tooltip)
	tooltip:AddLine("Bag Info",1,1,1);
	for bag = 0, NUM_BAG_SLOTS do
		if (GetBagName(bag)) then
			tooltip:AddDoubleLine(GetBagName(bag),format("%.2d / %.2d",info[bag].slots - info[bag].used,info[bag].slots),nil,nil,nil,1,1,1);
		end
	end
	tooltip:AddLine(" ");
	tooltip:AddDoubleLine("Used Slots",info.usedTotal.." / "..info.maxTotal,nil,nil,nil,1,1,1);
	tooltip:AddDoubleLine("Free Slots",(info.maxTotal - info.usedTotal).." / "..info.maxTotal,nil,nil,nil,1,1,1);
end

-- OnEvent
function plugin:BAG_UPDATE(event,bagID)
	info.maxTotal = 0;
	info.usedTotal = 0;
	-- Loop
	for bag = 0, NUM_BAG_SLOTS do
		info[bag].slots = GetContainerNumSlots(bag);
		free, type = GetContainerNumFreeSlots(bag);
		info[bag].used = (info[bag].slots - free);
		-- Don't include quivers
		if (type ~= 1) then
			info.usedTotal = (info.usedTotal + info[bag].used);
			info.maxTotal = (info.maxTotal + info[bag].slots);
		end
	end
	self:SetText("%d / %d",info.maxTotal - info.usedTotal,info.maxTotal);
end
plugin.PLAYER_LOGIN = plugin.BAG_UPDATE;

--------------------------------------------------------------------------------------------------------
--                                              Finalize                                              --
--------------------------------------------------------------------------------------------------------

plugin.icon:SetTexture("Interface\\Icons\\INV_Misc_Bag_EnchantedMageweave");
plugin:SetScript("OnClick",function() ToggleAllBags(); end);
plugin:RegisterEvent("BAG_UPDATE");
plugin:RegisterEvent("PLAYER_LOGIN");