local f = InfoPanel:AddPlugin();
local nextUpdate = 0;
local GetUnitSpeed = GetUnitSpeed;

--------------------------------------------------------------------------------------------------------
--                                             Functions                                              --
--------------------------------------------------------------------------------------------------------

local function OnUpdate(self,elapsed)
	nextUpdate = (nextUpdate - elapsed);
	if (nextUpdate <= 0) then
		self:SetText("%.1f%%",GetUnitSpeed("player") / 7 * 100);
		nextUpdate = 0.5;
	end
end

-- OnShowTooltip
function f:OnShowTooltip(tooltip)
	tooltip:AddLine("Movement Speed",1,1,1);
	tooltip:AddDoubleLine("Base Speed (7)",format("%.3f",GetUnitSpeed("player")),nil,nil,nil,1,1,1);
	tooltip:AddDoubleLine("Facing",format("%.3f",GetPlayerFacing() / math.pi / 2 * 360),nil,nil,nil,1,1,1);
	if (UnitExists("target")) then
		tooltip:AddDoubleLine("Target Speed",format("%.2f%%",GetUnitSpeed("target") / 7 * 100),nil,nil,nil,1,1,1);
	end
	if (UnitExists("pet")) then
		tooltip:AddDoubleLine("Pet Speed",format("%.2f%%",GetUnitSpeed("pet") / 7 * 100),nil,nil,nil,1,1,1);
	end
	if (UnitExists("vehicle")) then
		tooltip:AddDoubleLine("Vehicle Speed",format("%.2f%%",GetUnitSpeed("vehicle") / 7 * 100),nil,nil,nil,1,1,1);
	end
end

local function OnClick(self,button)
	local editBox = ChatEdit_GetActiveWindow();
	if (editBox) and (editBox:IsVisible()) then
		editBox:Insert(f.text:GetText());
	end
end

--------------------------------------------------------------------------------------------------------
--                                              Finalize                                              --
--------------------------------------------------------------------------------------------------------

--f.icon:SetTexture("Interface/Icons/Ability_Rogue_Sprint_Blue");
--f.icon:SetTexture("Interface/Icons/Ability_Rogue_Sprint");
--f.icon:SetTexture("Interface/Icons/SPELL_LIFEGIVINGSPEED");
f.icon:SetTexture("Interface/Icons/Spell_Fire_BurningSpeed");

f:SetScript("OnUpdate",OnUpdate);
f:SetScript("OnClick",OnClick);